#include <bits/stdc++.h>
using namespace std;

void vypis_strom(const vector< pair<int,int> > hrany) {
    for (auto h : hrany) cout << h.first+1 << " " << h.second+1 << "\n";
}

void vyrob_strom(vector<int> cisla_velkych, vector<int> stupne_velkych, vector<int> cisla_listov, bool hviezda=false) {
    vector< pair<int,int> > hrany;
    int lo = 0;
    if (hviezda) {
        // najdi vnutorny vrchol stupna >= 3 a spoj ho s troma inymi vnutornymi vrcholmi
        int velky = 0;
        while (stupne_velkych[velky] == 2) ++velky;
        swap( cisla_velkych[0], cisla_velkych[velky] );
        swap( stupne_velkych[0], stupne_velkych[velky] );
        for (int i=1; i<=3; ++i) {
            hrany.push_back( { cisla_velkych[0], cisla_velkych[i] } );
            --stupne_velkych[0];
            --stupne_velkych[i];
        }
        lo = 3;
    }
    // pospajaj zvysne vnutorne vrcholy do cesty
    for (unsigned i=lo; i+1<cisla_velkych.size(); ++i) {
        hrany.push_back( { cisla_velkych[i], cisla_velkych[i+1] } );
        --stupne_velkych[i];
        --stupne_velkych[i+1];
    }
    // pridaj listy
    for (unsigned i=0; i<cisla_velkych.size(); ++i) {
        while (stupne_velkych[i]--) {
            int list = cisla_listov.back();
            cisla_listov.pop_back();
            hrany.push_back( { cisla_velkych[i], list } );
        }
    }
    vypis_strom(hrany);
}

int main() {
    int T; cin >> T;
    int N; cin >> N;
    vector<int> cisla_velkych, stupne_velkych, cisla_listov;
    int sumd = 0;
    for (int n=0; n<N; ++n) { 
        int d; cin >> d; sumd += d; 
        if (d > 1) { cisla_velkych.push_back(n); stupne_velkych.push_back(d); }
        if (d == 1) cisla_listov.push_back(n);
    }
    // osetri pripady kedy existuje nanajvys jedno riesenie
    if (sumd != 2*(N-1)) { cout << "0\n"; return 0; }
    if (N == 2) { cout << "1\n1 2\n"; return 0; }
    int V = cisla_velkych.size();
    int mn = *min_element(stupne_velkych.begin(),stupne_velkych.end());
    int mx = *max_element(stupne_velkych.begin(),stupne_velkych.end());
    if (V <= 2 || mx == 2 || (V == 3 && mx == mn)) {
        cout << "1\n";
        vyrob_strom(cisla_velkych,stupne_velkych,cisla_listov);
        return 0;
    }
    // osetri pripady kedy existuju dve riesenia
    cout << "2\n";
    if (V >= 4) {
        vyrob_strom(cisla_velkych,stupne_velkych,cisla_listov);
        vyrob_strom(cisla_velkych,stupne_velkych,cisla_listov,true);
    } else {
        // dame na kraj cesty vrchol s unikatnym stupnom
        while (stupne_velkych[0] == stupne_velkych[1] || stupne_velkych[0] == stupne_velkych[2]) {
            rotate( cisla_velkych.begin(), cisla_velkych.begin()+1, cisla_velkych.end() );
            rotate( stupne_velkych.begin(), stupne_velkych.begin()+1, stupne_velkych.end() );
        }
        vyrob_strom(cisla_velkych,stupne_velkych,cisla_listov);
        // a nasledne ho dame do stredu cesty
        rotate( cisla_velkych.begin(), cisla_velkych.begin()+2, cisla_velkych.end() );
        rotate( stupne_velkych.begin(), stupne_velkych.begin()+2, stupne_velkych.end() );
        vyrob_strom(cisla_velkych,stupne_velkych,cisla_listov);
    }
}
